; $Id: dm_mask_detbanks.pro,v 1.8 2008/03/19 20:46:50 ymqiu Exp $
;#######################################################################
;
; NAME:
;  dm_mask_detbanks
;
; PURPOSE:
;  mask detector banks
;
; CATEGORY:
;  dcs_mslice
;
; AUTHOR:
;  Yiming Qiu
;  NIST Center for Neutron Research
;  100 Bureau Drive, Gaithersburg, MD 20899-6102
;  United States
;  yiming.qiu@nist.gov
;  March, 2008
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used or if the code in this file is
;  included in another product.
;
;#######################################################################

; parameter:
;   banks:    dcs detector bank number to be masked -1:lower 0:central 1:upper
function dm_mask_detbanks,banks
    banknum=[$
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1,$
        1, 1, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0, 0, 0,-1,-1, 1, 1,$
        0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1,$
        1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1,$
        1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 0, 0, 1, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1, 0]
    for i=0,n_elements(banks)-1 do begin
        if abs(banks[i]) le 1 then begin
           if n_elements(mask) eq 0 then $
              mask = where(banknum eq banks[i]) $
           else $
              mask = [mask,where(banknum eq banks[i])]
        endif
    endfor
    if n_elements(mask) eq 0 then mask=-1
    mask = mask[sort(mask)]
    return,mask
end

;mask DCS detector banks or negative angle detectors
;parameter:
;   detbanks:   a string description
pro dcs_mslice::dm_mask_detbanks, detbanks
    if self.ftype ne 0 then begin   ;only for DCS instrument
       ok = dialog_message('Invalid operation for non-DCS data.',/error,dialog_parent=self.tlb)
       return
    endif
    mkngBut = widget_info(self.tlb,find_by_uname='mkngBut')
    mkcnBut = widget_info(self.tlb,find_by_uname='mkcnBut')
    mkloBut = widget_info(self.tlb,find_by_uname='mkloBut')
    mkupBut = widget_info(self.tlb,find_by_uname='mkupBut')
    mkulBut = widget_info(self.tlb,find_by_uname='mkulBut')
    mkmlBut = widget_info(self.tlb,find_by_uname='mkmlBut')
    mkucBut = widget_info(self.tlb,find_by_uname='mkucBut')
    case strlowcase(detbanks) of
         'negative': begin  ;mask negative angle detectors
                     mask   = where((*self.detPosPtr).two_theta lt 0)
                     onbut  = mkngBut
                     offbut = [mkcnBut,mkloBut,mkupBut,mkulBut,mkmlBut,mkucBut]
                     end
         'center':   begin  ;mask central bank
                     mask   = dm_mask_detbanks(0)
                     onbut  = mkcnBut
                     offbut = [mkngBut,mkloBut,mkupBut,mkulBut,mkmlBut,mkucBut]
                     end
         'lower':    begin  ;mask lower bank
                     mask   = dm_mask_detbanks(-1)
                     onbut  = mkloBut
                     offbut = [mkngBut,mkcnBut,mkupBut,mkulBut,mkmlBut,mkucBut]
                     end
         'upper':    begin  ;mask upper bank
                     mask   = dm_mask_detbanks(1)
                     onbut  = mkupBut
                     offbut = [mkngBut,mkcnBut,mkloBut,mkulBut,mkmlBut,mkucBut]
                     end
         'uplow':    begin  ;mask upper and lower banks
                     mask   = dm_mask_detbanks([-1,1])
                     onbut  = mkulBut
                     offbut = [mkngBut,mkcnBut,mkloBut,mkupBut,mkmlBut,mkucBut]
                     end
         'cenlow':   begin  ;mask central and lower banks
                     mask   = dm_mask_detbanks([-1,0])
                     onbut  = mkmlBut
                     offbut = [mkngBut,mkcnBut,mkloBut,mkupBut,mkulBut,mkucBut]
                     end
         'upcen':    begin  ;mask upper and central banks
                     mask   = dm_mask_detbanks([0,1])
                     onbut  = mkucBut
                     offbut = [mkngBut,mkcnBut,mkloBut,mkupBut,mkulBut,mkmlBut]
                     end
         else:
    endcase
    if n_elements(mask) ne 0 then begin
       ptr_free,self.mask
       self.mask = ptr_new(mask,/no_copy)
       dm_toggle_menubut,onbut,offbut
       self->my_widget_control,['mksvBut','mkclBut'],sensitive=1
    endif
end
