; $Id: launch_nsescanpreviewer.pro,v 1.1 2007/03/27 16:08:07 kneller Exp $
;###############################################################################
;
;FILENAME:
;launch_nsescanpreviewer.pro
;
;PURPOSE:
;           Launch NSEScanPreviewer from DAVE.
;CATEGORY:
;
;
;METHODS IN FILE:
;
;    launch_nsescanpreviewer
;
;
; AUTHOR:
; Larry Kneller
; NIST Center for Neutron Research
; 100 Bureau Drive, Gaithersburg, MD 20899
; United States
; kneller@nist.gov  301-975-8839
; Mar 27,2007
;
; LICENSE:
; The software in this file is written by an employee of
; National Institute of Standards and Technology
; as part of the DAVE software project.
;
; The DAVE software package is not subject to copyright protection
; and is in the public domain. It should be considered as an
; experimental neutron scattering data reduction, visualization, and
; analysis system. As such, the authors assume no responsibility
; whatsoever for its use, and make no guarantees, expressed or
; implied, about its quality, reliability, or any other
; characteristic. The use of certain trade names or commercial
; products does not imply any endorsement of a particular product,
; nor does it imply that the named product is necessarily the best
; product for the stated purpose. We would appreciate acknowledgment
; if the DAVE software is used of if the code in this file is
; included in another product.
;
;###############################################################################
;
pro launch_nsescanpreviewer,event
;
;NAME:
;        launch_nsescanpreviewer
;
;PURPOSE:
;           Launch NSEScanPreview from DAVE.
;PARAMETERS:
;           event   Event to launch the module.
;KEYWORDS:
;           None.



    ; Launching program for the NSE Scan Previewer.

    if n_elements(event) gt 0 then begin
        this_event = tag_names(event,/structure_name)

        case this_event of
        'WIDGET_BUTTON': $
            begin
                workdir = (*!dave_defaults).workDir
                datadir = (*!dave_defaults).datDir
                device,decomposed = 0
                NSEScanPreview,group_leader=event.top,workdir=workdir,datadir=datadir
            end
        'WIDGET_TREE_SEL': $
            begin
                workdir = (*!dave_defaults).workDir
                datadir = (*!dave_defaults).datDir
                NSEScanPreview,group_leader=event.top,workdir=workdir,datadir=datadir
            end
        'NSE_EVENT': $
            begin
                NSEScanPreview,group_leader=event.top
            end
        else:
        endcase
    endif

end;launch_nsescanpreviewer


