; $Id: launch_dave_bt7psdreduction.pro,v 1.1 2008/04/11 09:55:20 williamratcliff Exp $
;###############################################################################
;
; NAME:
;   launch_dave_bt7psdreduction
;
; PURPOSE:
;   Launch procedure for the 'bt7 psd reduction' module in DAVE.
;
; CATEGORY:
;   TAS Data Reduction
;
; AUTHOR:
;   Richard Tumanjong Azuah
;   NIST Center for Neutron Research
;   100 Bureau Drive, Gaithersburg, MD 20899
;   United States
;   azuah@nist.gov; (301) 9755604
;   April, 2003
;
; LICENSE:
;  The software in this file is written by an employee of 
;  National Institute of Standards and Technology 
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################



;===============================================================================
; launch_dave_calibratePSD
;
; PURPOSE:
;   Launch procedure for the 'calibratePSD' module in DAVE.
;
;
pro launch_dave_bt7psdreduction,event

widget_control,event.top,get_uvalue = pState

crystalbt7psd, GROUP_LEADER=event.top,workDir=(*!dave_defaults).workDir,dataDir=(*!dave_defaults).datDir

end
